function [CKtransitions, CKtransindex] = CKedgedetection(donorin, acceptorin, fretin, window, percentile, separation, starttime, timestep)

% NOTE: This program has all the pieces to calculate transitions in the donor and acceptor traces. However, the t-test is 
% only set up for the FRET data, and the unused code is commented out.

time = starttime:timestep:(length(fretin)-1)*timestep + starttime;
lendata = min(length(donorin),min(length(acceptorin),length(fretin)));
lenP = length(percentile);

% Output matrices.
frtbapred(lendata) = 0; frtfwpred(lendata) = 0;
%donbapred(lendata) = 0; donfwpred(lendata) = 0;
%accbapred(lendata) = 0; accfwpred(lendata) = 0;

% Looping through the timepoints
for tpts = 1:min(length(donorin),length(acceptorin))
    
    % If we're at a data point within the largest window size from the start or end of the data...
    if tpts-window-1 >0 && tpts+window+1<= min(length(donorin),length(acceptorin))
            
        frtbapred(tpts) = std(fretin(tpts-window-1:tpts-1))^2;
        frtfwpred(tpts) = std(fretin(tpts+1:tpts+window+1))^2;           
%         frtbapred(tpts) = std(acceptorin(tpts-window-1:tpts-1))^2;
%         frtfwpred(tpts) = std(acceptorin(tpts+1:tpts+window+1))^2;

        %donbapred(tpts) = std(donorin(tpts-window-1:tpts-1))^2;
        %donfwpred(tpts) = std(donorin(tpts+1:tpts+window+1))^2;
           
        %accbapred(tpts) = std(acceptorin(tpts-window-1:tpts-1))^2;
        %accfwpred(tpts) = std(acceptorin(tpts+1:tpts+window+1))^2;
    end
end 

% Finding locations where the predictor window's standard deviation is highest (which should happen when a 
% transition occurs within that window). StDevs higher than the input percentiles are kept.
%dbloc = zeros(ceil(lendata/separation),lenP); dfloc = zeros(ceil(lendata/separation),lenP);
%abloc = zeros(ceil(lendata/separation),lenP); afloc = zeros(ceil(lendata/separation),lenP);
fbloc = zeros(ceil(lendata/separation),lenP); ffloc = zeros(ceil(lendata/separation),lenP);

for PCT = 1:lenP
    loc1=0; loc2=0; loc3=0; loc4=0; loc5=0; loc6=0;
    %[~, loc1] = findpeaks(donbapred,'minpeakheight',prctile(donbapred,percentile(PCT)),'minpeakdistance',separation);
    %[~, loc2] = findpeaks(donfwpred,'minpeakheight',prctile(donfwpred,percentile(PCT)),'minpeakdistance',separation);
    %[~, loc3] = findpeaks(accbapred,'minpeakheight',prctile(accbapred,percentile(PCT)),'minpeakdistance',separation);
    %[~, loc4] = findpeaks(accfwpred,'minpeakheight',prctile(accfwpred,percentile(PCT)),'minpeakdistance',separation);
%     [~, loc5] = findpeaks(frtbapred,'minpeakheight',max(0.02,prctile(frtbapred,percentile(PCT))),'minpeakdistance',separation);
%     [~, loc6] = findpeaks(frtfwpred,'minpeakheight',max(0.02,prctile(frtfwpred,percentile(PCT))),'minpeakdistance',separation);
    [~, loc5] = findpeaks(frtbapred,'minpeakheight',percentile,'minpeakdistance',separation);
    [~, loc6] = findpeaks(frtfwpred,'minpeakheight',percentile,'minpeakdistance',separation);
%{
    for t = 1:length(loc1)
        dbloc(t,PCT) = loc1(t);
    end
    for t = 1:length(loc2)
        dfloc(t,PCT) = loc2(t);
    end
    for t = 1:length(loc3)
        abloc(t,PCT) = loc3(t);
    end
    for t = 1:length(loc4)
        afloc(t,PCT) = loc4(t);
    end
%}
    for t = 1:length(loc5)
        fbloc(t,PCT) = loc5(t);
    end
    for t = 1:length(loc6)
        ffloc(t,PCT) = loc6(t);
    end       
end

% Fixing the windows for the offset between forward and backward windows.
offset = (window/2)+1; 
for PCT = 1:lenP
    %{
    for i = 1:length(dbloc)
        if dbloc(i,PCT) ~= 0;
            dbloc(i,PCT) = dbloc(i,PCT)-offset;
        end
    end
    for i = 1:length(dfloc)
        if dfloc(i,PCT) ~= 0;
            dfloc(i,PCT) = dfloc(i,PCT)+offset;
        end
    end
    for i = 1:length(abloc)
        if abloc(i,PCT) ~= 0;
            abloc(i,PCT) = abloc(i,PCT)-offset;
        end
    end
    for i = 1:length(afloc)
        if afloc(i,PCT) ~= 0;
            afloc(i,PCT) = afloc(i,PCT)+offset;
        end
    end
    %}
    for i = 1:length(fbloc)
        if fbloc(i,PCT) ~= 0
            fbloc(i,PCT) = fbloc(i,PCT)-offset;
        end
    end
    for i = 1:length(ffloc)
        if ffloc(i,PCT) ~= 0
            ffloc(i,PCT) = ffloc(i,PCT)+offset;
        end
    end    
end

%dtransloc = 0; dtransloc = [dbloc; dfloc];
%atransloc = 0; atransloc = [abloc; afloc];
ftransloc = 0; ftransloc = [fbloc; ffloc];

% Only keeping those transitions identified by both the forward and backward predictors.
for PCT = 1:lenP
    %didx = 0; aidx = 0; 
    fidx = 0;
    %[~, didx] = unique(dtransloc(:,PCT));
    %[~, aidx] = unique(atransloc(:,PCT));
    [~, fidx] = unique(ftransloc(:,PCT));
    
    %dtransloc(didx,PCT) = 0;
    %atransloc(aidx,PCT) = 0;
    ftransloc(fidx,PCT) = 0;
end

%Making an array of zeros and ones, where ones signify transitions.
%dtransindex = zeros(lendata,lenP);
%atransindex = zeros(lendata,lenP);
ftransindex = zeros(lendata,lenP);

for PCT = 1:lenP
    %{
    for idx = 1:length(dtransloc)
        if dtransloc(idx,PCT) ~= 0;
            dtransindex(dtransloc(idx,PCT),PCT) = 1;
        end
    end
    for idx = 1:length(atransloc)
        if atransloc(idx,PCT) ~= 0;
            atransindex(atransloc(idx,PCT),PCT) = 1;
        end
    end
    %}
    for idx = 1:length(ftransloc)
        if ftransloc(idx,PCT) ~= 0
            ftransindex(ftransloc(idx,PCT),PCT) = 1;
        end
    end
end

%dtransitions = sum(dtransindex,2);
%atransitions = sum(atransindex,2);
CKtransitions = sum(ftransindex,2);

% Applying a t-test to the FRET states between each transition, and only keeping significantly different states.
boundaries = 0; alltransindex = 0;
alltransindex = find(CKtransitions(:,1)); 
boundaries = [1; alltransindex; lendata];
if max(boundaries) ~= boundaries(end)
    boundaries(boundaries==max(boundaries))=[];
end
ttestctr = 1;

while ttestctr < (length(boundaries)-2)
    testregion = boundaries(ttestctr):boundaries(ttestctr+1)-1;
    testnextregion = boundaries(ttestctr+1):boundaries(ttestctr+2)-1;
    ttestresult = ttest2(fretin(testregion), fretin(testnextregion), 'Vartype','unequal', 'Alpha', 0.6);
    if ttestresult == 1
        ttestctr = ttestctr+1;
    else
        boundaries(ttestctr+1) = [];
    end
end
   
CKtransindex(:,1) = boundaries(2:end-1);
badtransindex = (1:1:length(fretin));
for a = 1:length(CKtransindex)
    badtransindex(CKtransindex(a))=0;
end
badtransindex(badtransindex==0)=[];
for b = 1:length(badtransindex)
    CKtransitions(badtransindex(b))=0;
end