function [k1coff, k2coff, k1index,k2index] = Parametertest(FileName1,PathName,FileName2,result3)
% Opening the folder containing the .traces files.
firstmovie = strrep(strrep(FileName1,'trace_',''),'.txt','');
lastmovie = strrep(strrep(FileName2,'trace_',''),'.txt','');
startnum = str2num(firstmovie);
endnum = str2num(lastmovie);

directory=[PathName, '/'];
disp(directory)
cd(directory);  
close all;

experiment={'0.4 50 0.2','0','1'};
frameproperty = str2num(experiment{1});
starttime = frameproperty(1,1);
endtime = frameproperty(1,2);
timestep = frameproperty(1,3);


k1 = [];
k2 = [];
k1index = 1;
k2index = 1;
for movienum = startnum:endnum	
    file = ['trace_' num2str(movienum)];
    to_open = strcat(file,'.txt');
    
    if exist(to_open) == 2
        close all;
        disp(['Open file' to_open]);
        raw=importdata(to_open);
        [baddata,CKtrans_aligned,frt_avg] = Edgefind(raw.data,result3,starttime,endtime,timestep);
        disp('Edge finding done, extracting the results');

        tranidx = find(CKtrans_aligned);    

        if length(tranidx)<3
            continue;
        end
        SeparationFRET = 0.55;

        % Empty Matrices for the Outputs
        reg_sta = zeros(length(tranidx)+1,1);
        reg_end = zeros(length(tranidx)+1,1);

        % First Transition:
        reg_sta(1,:) = 1;
        reg_end(1,:) = tranidx(1);


        % Middle Transitions
        for k = 2:length(tranidx)-1
            reg_sta(k,:) = tranidx(k-1);
            reg_end(k,:) = tranidx(k);
            region = reg_sta(k,:):reg_end(k,:);
            prevregion = reg_sta(k-1,:):reg_sta(k,:);
            nextregion = reg_end(k,:):tranidx(k+1);
            if mode(baddata(region)) ~= 1
                if mode(baddata(prevregion)) == 1 || mode(baddata(nextregion)) == 1
                elseif mode(frt_avg(region)) < SeparationFRET
                    k1(k1index,1) = reg_end(k)-reg_sta(k);
                    k1index = k1index + 1;
                else
                    k2(k2index,1) = reg_end(k)-reg_sta(k);
                    k2index = k2index + 1;
                end
            end
        end

        % Penultimate Transition:
        reg_sta(end-1,:) = tranidx(length(tranidx)-1);
        reg_end(end-1,:) = tranidx(length(tranidx));
        region = reg_sta(end-1,:):reg_end(end-1,:);
        prevregion = reg_sta(end-2,:):reg_sta(end-1,:);
        nextregion = reg_end:length(frt_avg);
        if mode(baddata(region)) ~= 1
            if mode(baddata(prevregion)) == 1 || mode(baddata(nextregion)) == 1
            elseif mode(frt_avg(region)) < SeparationFRET
                k1(k1index,1) = reg_end(k)-reg_sta(k);
                k1index = k1index + 1;
            else
                k2(k2index,1) = reg_end(k)-reg_sta(k);
                k2index = k2index + 1;
            end
        end

        % Final Transition
        reg_sta(end,:) = tranidx(length(tranidx));
        reg_end(end,:) = length(frt_avg);
    end 
end
k1 = k1*timestep;
k2 = k2*timestep;

Upperlimit = 1.4*(fix(max(k1))+1);
len = length(k1);
Timepoint = (1.6:1.6:Upperlimit)';
DT = zeros(length(Timepoint),1);
for m = 1:len
    DT(fix(k1(m,1)/1.6+1)) = DT(fix(k1(m,1)/1.6+1)) + 1;
end
CutTimepoint = Timepoint(2:end,1);
CutDT = DT(2:end,1);
ETfittype = fittype('a*exp(-k*t)','independent','t');
f1 = fit(CutTimepoint,CutDT,ETfittype,'StartPoint',[800 0.2]);
coeffval1 = coeffvalues(f1);
k1coff = coeffval1(1,2);

Upperlimit = 1.4*(fix(max(k2))+1);
len = length(k2);
Timepoint = (1.6:1.6:Upperlimit)';
DT = zeros(length(Timepoint),1);
for m = 1:len
    DT(fix(k2(m,1)/1.6+1)) = DT(fix(k2(m,1)/1.6+1)) + 1;
end
CutTimepoint = Timepoint(2:end,1);
CutDT = DT(2:end,1);
ETfittype = fittype('a*exp(-k*t)','independent','t');
f2 = fit(CutTimepoint,CutDT,ETfittype,'StartPoint',[800 0.2]);
coeffval1 = coeffvalues(f2);
k2coff = coeffval1(1,2);
